// Connect.cpp : Implementation of CConnect
#include "stdafx.h"
#include <atlfile.h>
#include <algorithm>
#include <limits>

#include "AddIn.h"
#include "Connect.h"

#include "hr.h"
//#include <todo.h>  // Super TODO: this can be safely removed,
                   // only #pragma TODO's will go undetected.

extern CAddInModule _AtlModule;

struct VerInfo
{
	VerInfo()
		: us1( 0 ),
		us2( 0 ),
		us3( 0 ),
		us4( 0 )
	{}

	unsigned short us1, us2, us3, us4;

	void operator ++ ()
	{
#ifdef max
#pragma push_macro( "max" )
#undef max
#define Restore_max_863895DE_1931_451f_840E_2E16785F3580
#endif
		unsigned short const max = std::numeric_limits< unsigned short >::max();
		if (us4 == max)
		{
			us4 = 0;
			if (us3 == max)
			{
				us3 = 0;
				if (us2 == max)
				{
					us2 = 0;
					++ us1;
				}
				else
					++ us2;
			}
			else
				++ us3;
		}
		else
			++ us4;
#ifdef Restore_max_863895DE_1931_451f_840E_2E16785F3580
#undef Restore_max_863895DE_1931_451f_840E_2E16785F3580
#pragma pop_macro( "max" )
#endif
	}

	void operator ++ (int)
	{
		++ (*this);
	}

	operator bool () const
	{
		return !(us1 == 0 && us2 == 0 && us3 == 0 && us4 == 0);
	}

	void ToString(char (&sz)[ 24 ], char chSep) const
	{
		::sprintf( sz, "%hu%c%hu%c%hu%c%hu", us1, chSep, us2, chSep,
			us3, chSep, us4 );
	}

	void ToString(wchar_t (&sz)[ 24 ], wchar_t chSep) const
	{
		::swprintf( sz, L"%hu%c%hu%c%hu%c%hu", us1, chSep, us2, chSep,
			us3, chSep, us4 );
	}
};

const TCHAR * const CConnect::s_szVersionInfo = _T("VERSIONINFO");
const TCHAR * const CConnect::s_szBegin1 = _T("BEGIN");
const TCHAR * const CConnect::s_szBegin2 = _T("{");
const TCHAR * const CConnect::s_szEnd1 = _T("END");
const TCHAR * const CConnect::s_szEnd2 = _T("}");
const TCHAR * const CConnect::s_szFileVersion1 = _T("FILEVERSION");
const TCHAR * const CConnect::s_szFileVersion2 = _T("\"FileVersion\"");
const TCHAR * const CConnect::s_szProductVersion1 = _T("PRODUCTVERSION");
const TCHAR * const CConnect::s_szProductVersion2 = _T("\"ProductVersion\"");

// When run, the Add-in wizard prepared the registry for the Add-in.
// At a later time, if the Add-in becomes unavailable for reasons such as:
//   1) You moved this project to a computer other than which is was originally created on.
//   2) You chose 'Yes' when presented with a message asking if you wish to remove the Add-in.
//   3) Registry corruption.
// you will need to re-register the Add-in by building the MyAddin21Setup project 
// by right clicking the project in the Solution Explorer, then choosing install.


// CConnect
CConnect::CConnect()
	: m_bAutoloadExternalChanges( false ),
	m_bDetectFileChangesOutsideIDE( false )
{
}

STDMETHODIMP CConnect::OnConnection(IDispatch *pApplication, AddInDesignerObjects::ext_ConnectMode ConnectMode, IDispatch *pAddInInst, SAFEARRAY ** /*custom*/ )
{
	HRESULT hr = S_OK;
	pApplication->QueryInterface(__uuidof(EnvDTE::_DTE), (LPVOID*)&m_pDTE);
	pAddInInst->QueryInterface(__uuidof(EnvDTE::AddIn), (LPVOID*)&m_pAddInInstance);

	if (m_pDTE)
	{
		CComPtr< EnvDTE::Events > pEvt;
		m_pDTE->get_Events( &pEvt );
		pEvt->get_BuildEvents( &m_pEvents );
		ATLASSERT(m_pEvents);
		DTE_BuildEvents::DispEventAdvise( m_pEvents );
	}

	if(ConnectMode == 5) //5 == AddInDesignerObjects::ext_cm_UISetup)
	{
		HRESULT hr = S_OK;
		CComPtr<EnvDTE::Commands> pCommands;
		CComPtr<Office::_CommandBars> pCommandBars;
		CComPtr<Office::CommandBarControl> pCommandBarControl;
		CComPtr<EnvDTE::Command> pCreatedCommand;
		CComPtr<Office::CommandBar> pMenuBarCommandBar;

    // When run, the Add-in wizard prepared the registry for the Add-in.
    // At a later time, the Add-in or its commands may become unavailable for reasons such as:
    //   1) You moved this project to a computer other than which is was originally created on.
    //   2) You chose 'Yes' when presented with a message asking if you wish to remove the Add-in.
    //   3) You add new commands or modify commands already defined.
    // You will need to re-register the Add-in by building the VersionManagerSetup project,
    // right-clicking the project in the Solution Explorer, and then choosing install.
    // Alternatively, you could execute the ReCreateCommands.reg file the Add-in Wizard generated in 
    // the project directory, or run 'devenv /setup' from a command prompt.
		IfFailGoCheck(m_pDTE->get_Commands(&pCommands), pCommands);
		if(SUCCEEDED(pCommands->AddNamedCommand(m_pAddInInstance, CComBSTR("VersionManager"), CComBSTR("VersionManager"), CComBSTR("Executes the command for VersionManager"), VARIANT_TRUE, 59, NULL, EnvDTE::vsCommandStatusSupported+EnvDTE::vsCommandStatusEnabled, &pCreatedCommand)) && (pCreatedCommand))
		{
			//Add a button to the tools menu bar.
			IfFailGoCheck(m_pDTE->get_CommandBars(&pCommandBars), pCommandBars);
			IfFailGoCheck(pCommandBars->get_Item(CComVariant(L"Tools"), &pMenuBarCommandBar), pMenuBarCommandBar);
			IfFailGoCheck(pCreatedCommand->AddControl(pMenuBarCommandBar, 1, &pCommandBarControl), pCommandBarControl);
		}
		return S_OK;
	}
Error:
	return hr;
}

STDMETHODIMP CConnect::OnDisconnection(AddInDesignerObjects::ext_DisconnectMode /*RemoveMode*/, SAFEARRAY ** /*custom*/ )
{
	if (m_pEvents)
	{
		DTE_BuildEvents::DispEventUnadvise( m_pEvents );
	}

	m_pDTE = NULL;
	m_pEvents = NULL;
	return S_OK;
}

STDMETHODIMP CConnect::OnAddInsUpdate (SAFEARRAY ** /*custom*/ )
{
	return S_OK;
}

STDMETHODIMP CConnect::OnStartupComplete (SAFEARRAY ** /*custom*/ )
{
	return S_OK;
}

STDMETHODIMP CConnect::OnBeginShutdown (SAFEARRAY ** /*custom*/ )
{
	return S_OK;
}

STDMETHODIMP CConnect::QueryStatus(BSTR bstrCmdName, EnvDTE::vsCommandStatusTextWanted NeededText, EnvDTE::vsCommandStatus *pStatusOption, VARIANT * /*pvarCommandText*/)
{
  if(NeededText == EnvDTE::vsCommandStatusTextWantedNone)
	{
	  if(!_wcsicmp(bstrCmdName, L"VersionManager.Connect.VersionManager"))
	  {
		  *pStatusOption = (EnvDTE::vsCommandStatus)(EnvDTE::vsCommandStatusEnabled+EnvDTE::vsCommandStatusSupported);
	  }
  }
	return S_OK;
}

STDMETHODIMP CConnect::Exec(BSTR bstrCmdName, EnvDTE::vsCommandExecOption ExecuteOption, VARIANT * /*pvarVariantIn*/, VARIANT * /*pvarVariantOut*/, VARIANT_BOOL *pvbHandled)
{
	*pvbHandled = VARIANT_FALSE;
	if(ExecuteOption == EnvDTE::vsCommandExecOptionDoDefault)
	{
		if(!_wcsicmp(bstrCmdName, L"VersionManager.Connect.VersionManager"))
		{
			*pvbHandled = VARIANT_TRUE;
			return S_OK;
		}
	}
	return S_OK;
}

STDMETHODIMP CConnect::OnBuildBegin(EnvDTE::vsBuildScope Scope,
									EnvDTE::vsBuildAction Action)
{
	try
	{
		switch (Action)
		{
		case EnvDTE::vsBuildActionBuild:
		case EnvDTE::vsBuildActionRebuildAll:
			IncrementVersion( Scope == EnvDTE::vsBuildScopeSolution );
			break;
		}
	}
	catch (...)
	{
#ifdef _DEBUG
		bool const AnExceptionThatShouldNotThrowIsThrown = false;
		ATLASSERT(AnExceptionThatShouldNotThrowIsThrown);
#endif
	}

	return S_OK;
}

void CConnect::IncrementVersion(bool bAll)
{
	if (bAll)
	{
		ProcessProjectGroups( _T("VCProjects") );
		ProcessProjectGroups( _T("VBProjects") );
		ProcessProjectGroups( _T("CSharpProjects") );
	}
	else
	{
#pragma TODO( "Add a function to process the active project" )
	}
}

void CConnect::ProcessProjectGroups(LPCTSTR pszGroup)
{
	HResult hr;

	try
	{
		CComPtr< IDispatch > pDisp;
		hr = m_pDTE->GetObject( _bstr_t( pszGroup ), &pDisp );

		CComQIPtr< EnvDTE::Projects > pProjects = pDisp;
		if (!pProjects)
			throw 0;

		long lCount = 0, lMax = 0;
		hr = pProjects->get_Count( &lMax );

		while (lCount < lMax)
		{
			CComPtr< EnvDTE::Project > pProject;
			hr = pProjects->Item( _variant_t( lCount + 1 ), &pProject );
			if (!pProject)
				continue;

			ProcessProjects( pProject, pszGroup );

			++ lCount;
		}
	}
	catch (...)
	{
	}
}

void CConnect::ProcessProjects(EnvDTE::Project * pProject, LPCTSTR pszGroup)
{
	if (::lstrcmp( pszGroup, _T("VCProjects") ) == 0)
		ProcessVCProjects( pProject );
	else ;
#pragma TODO( "Complete the ProcessVBProjects and ProcessCSharpProjects functions" )
}

void CConnect::ProcessVCProjects(EnvDTE::Project * pProject)
{
	HResult hr;

	// if the project is up to date, bail out
	try
	{
		CComPtr< IDispatch > pDisp;
		hr = pProject->get_Object( &pDisp );
		if (!pDisp)
			throw 0;

		CComQIPtr< VCProjectEngineLibrary::VCProject > pVCProj = pDisp;
		if (!pVCProj)
			throw 0;

		CComPtr< EnvDTE::ConfigurationManager > pConfMgr;
		hr = pProject->get_ConfigurationManager( &pConfMgr );
		if (!pConfMgr)
			throw 0;

		CComPtr< EnvDTE::Configuration > pActiveConf;
		hr = pConfMgr->get_ActiveConfiguration( &pActiveConf );
		if (!pActiveConf)
			throw 0;

		BSTR bstr = NULL;
		hr = pActiveConf->get_ConfigurationName( &bstr );
		if (!bstr)
			throw 0;
		_bstr_t bstrActiveConfName( bstr, false );
		bstr = NULL;

		CComPtr< IDispatch > pDispConfigs;
		hr = pVCProj->get_Configurations( &pDispConfigs );
		if (!pDispConfigs)
			throw 0;

		CComQIPtr< VCProjectEngineLibrary::IVCCollection > pCollConfs = pDispConfigs;
		if (!pCollConfs)
			throw 0;

		long lCount = 0, lMax = 0;

		hr = pCollConfs->get_Count( &lMax );
		while (lCount ++ < lMax)
		{
			CComPtr< IDispatch > pDispConf;

			hr = pCollConfs->Item( _variant_t( lCount ), &pDispConf );
			if (!pDispConf)
				throw 0;

			CComQIPtr< VCProjectEngineLibrary::VCConfiguration > pVCConf = pDispConf;
			if (pVCConf)
			{
				hr = pVCConf->get_ConfigurationName( &bstr );

				if (bstrActiveConfName == _bstr_t( bstr, false ))
				{
					VARIANT_BOOL bUpToDate = VARIANT_TRUE;

					hr = pVCConf->get_UpToDate( &bUpToDate );

					if (bUpToDate != VARIANT_FALSE)
					{
						// no need to increment the version
						// when it's up-to-date
						return;
					}
					else
					{
						break;
					}
				}

				bstr = NULL;
			}
		}
	}
	catch (...)
	{
	}

	CComPtr< EnvDTE::ProjectItems > pItems;
	hr = pProject->get_ProjectItems( &pItems );
	if (!pItems)
		throw 0;

	try
	{
		ProcessVCProjectItems( pItems );
	}
	catch (bool bResult)
	{
		ATLASSERT(bResult);
		// bResult is always true, and indicates that the rc file is correctly updated.
		bResult;
	}
	catch (...)
	{
		throw;
	}
}

void CConnect::ProcessVCProjectItems(EnvDTE::ProjectItems * pItems)
{
	HResult hr;

	long lCount = 0, lMax = 0;
	hr = pItems->get_Count( &lMax );

	while (lCount ++ < lMax)
	{
		CComPtr< EnvDTE::ProjectItem > pItem;
		hr = pItems->Item( _variant_t( lCount ), &pItem );
		if (!pItem)
			continue;

		short sFileCount = 0, sFileMax = 0;
		hr = pItem->get_FileCount( &sFileMax );

		while (sFileCount ++ < sFileMax)
		{
			BSTR bstr = NULL;
			hr = pItem->get_FileNames( sFileCount, &bstr );

			if (bstr)
			{
				_bstr_t bstrEnsureDelete( bstr, false );
				ProcessVCProjectFile( bstr );
			}

/*
VC++ 7.1 has changed the project item model from flat into hierarchial,
the following recursive code is there to handle this.
*/
#if _MSC_VER >= 1310 // only for VC++ .NET 2003 and above
			CComPtr< EnvDTE::ProjectItems > pSubItems;
			hr = pItem->get_ProjectItems( &pSubItems );
			if (pSubItems)
			{
				ProcessVCProjectItems( pSubItems );
			}
#endif
		}
	}
}

void CConnect::ProcessVCProjectFile(BSTR bstrFileName)
{
	UINT uiLen = ::SysStringLen( bstrFileName );
	if (uiLen > 3)
	{
		// check for the ".rc" extension
		if (::lstrcmpiW( &bstrFileName[ uiLen - 3 ], L".rc" ) == 0)
		{
			SetChangeDetectionOptions();

			__try
			{
				ProcessVCProjectRCFile( bstrFileName );
			}
			__finally
			{
				ResetChangeDetectionOptions();
			}
		}
	}
}

void CConnect::ProcessVCProjectRCFile(BSTR bstrFileName)
{
	CWin32HeapPtr< char > pNewContentsA;
	CWin32HeapPtr< wchar_t > pNewContentsW;

	SetChangeDetectionOptions();

	ProcessVCProjectRCFileInternal( bstrFileName, pNewContentsA, pNewContentsW );
}

void CConnect::ProcessVCProjectRCFileInternal(BSTR bstrFileName,
											  CWin32HeapPtr< char > & pNewContentsA,
											  CWin32HeapPtr< wchar_t > & pNewContentsW)
{
	if (!CheckSCCForRCFile( bstrFileName ))
		return;

	BackupFile( bstrFileName );

	ThrowOnError< HANDLE, ThrowOnErrorTraits< HANDLE, INVALID_HANDLE_VALUE > > hFile;
	ThrowOnError< HANDLE, ThrowOnErrorTraits< HANDLE, NULL > > hMap;
	wchar_t * pwszRC = NULL;
	bool bUnicode = true;

	__try
	{
		hFile = ::CreateFileW( bstrFileName, GENERIC_READ | GENERIC_WRITE,
			FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING,
			FILE_ATTRIBUTE_NORMAL, NULL );

		hMap = ::CreateFileMappingW( hFile, NULL, PAGE_READWRITE, 0, 0, NULL );

		const DWORD dwSize = ::GetFileSize( hFile, NULL );

		pwszRC = reinterpret_cast< wchar_t * >
			(::MapViewOfFileEx( hMap, FILE_MAP_WRITE, 0, 0, dwSize, NULL ));

		// check for the byte-order mask
		if (pwszRC[ 0 ] == 0xfeff &&
			::IsTextUnicode( &pwszRC[ 1 ], dwSize - sizeof(wchar_t), NULL ))
		{
			// Unicode file
			if (!pNewContentsW.AllocateBytes( dwSize / sizeof(wchar_t) ))
				throw 0;
			pNewContentsW.Add( pwszRC, sizeof(wchar_t) );

			ProcessRC< wchar_t >( &pwszRC[ 1 ], dwSize - sizeof(wchar_t),
				pNewContentsW );
		}
		else if (pwszRC[ 0 ] == 0xfffe)
		{
			FixUnicodeText( pwszRC, dwSize );
			if (::IsTextUnicode( &pwszRC[ 1 ], dwSize - sizeof(wchar_t), NULL ))
			{
				// Unicode file
				if (!pNewContentsW.AllocateBytes( dwSize / sizeof(wchar_t) ))
					throw 0;
				pNewContentsW.Add( pwszRC, sizeof(wchar_t) );

				ProcessRC< wchar_t >( &pwszRC[ 1 ], dwSize - sizeof(wchar_t),
					pNewContentsW );
			}
		}
		else
		{
			// ANSI file
			if (!pNewContentsA.AllocateBytes( dwSize / sizeof(char) ))
				throw 0;

			bUnicode = false;
			ProcessRC< char >( reinterpret_cast< char const * > (pwszRC), dwSize,
				pNewContentsA );
		}
	}
	__finally
	{
		if (pwszRC != NULL)
		{
			::UnmapViewOfFile( pwszRC );
			pwszRC = NULL;
		}
		if (hMap != NULL)
			::CloseHandle( hMap );
		if (hFile != INVALID_HANDLE_VALUE)
			::CloseHandle( hFile );
	}

	WriteRCFile( bstrFileName, pNewContentsA, pNewContentsW, bUnicode );

	// This exception indicates success, and will be caught upper in the call
	// stack, and processing will be aborted from that place.
	throw true;
}

void CConnect::WriteRCFile(BSTR bstrFileName, CWin32HeapPtr< char > & pNewContentsA,
						   CWin32HeapPtr< wchar_t > & pNewContentsW, bool bUnicode)
{
	ThrowOnError< HANDLE, ThrowOnErrorTraits< HANDLE, INVALID_HANDLE_VALUE > > hFile;
	ThrowOnError< HANDLE, ThrowOnErrorTraits< HANDLE, NULL > > hMap;
	void * pvContents = NULL;
	size_t newSize;
	void const * pvNew = NULL;
	if (bUnicode)
	{
		newSize = pNewContentsW.GetWrittenBytes();
		pvNew = static_cast< wchar_t * > (pNewContentsW);
	}
	else
	{
		newSize = pNewContentsA.GetWrittenBytes();
		pvNew = static_cast< char * > (pNewContentsA);
	}

	__try
	{
		hFile = ::CreateFileW( bstrFileName, GENERIC_WRITE | GENERIC_READ,
			FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );

		::SetLastError( NO_ERROR );
		::SetFilePointer( hFile, static_cast< LONG > (newSize), NULL, FILE_BEGIN );
		if (NO_ERROR != ::GetLastError() || !::SetEndOfFile( hFile ))
			__leave;

		hMap = ::CreateFileMappingW( hFile, NULL, PAGE_READWRITE, 0, 0, NULL );

		pvContents = ::MapViewOfFile( hMap, FILE_MAP_WRITE, 0, 0, newSize );

		::memcpy( pvContents, pvNew, newSize );
	}
	__finally
	{
		if (pvContents != NULL)
		{
			::UnmapViewOfFile( pvContents );
			pvContents = NULL;
		}
		if (hMap != NULL)
			::CloseHandle( hMap );
		if (hFile != INVALID_HANDLE_VALUE)
			::CloseHandle( hFile );
	}
}

void CConnect::FixUnicodeText(void * pvBuffer, DWORD cb)
{
	BYTE * pb = reinterpret_cast< BYTE * > (pvBuffer);
	for (DWORD dw = 0; dw < cb; dw += 2)
	{
		std::iter_swap( pb + dw, pb + dw + 1 );
	}
}

#if _MSC_VER == 1300
template < typename T >
void CConnect::ProcessRC< T >(T const * pBuffer, DWORD cb,
							  CWin32HeapPtr< T > & pNewContents)
#elif _MSC_VER == 1310
template < typename T >
void CConnect::ProcessRC(T const * pBuffer, DWORD cb,
						 CWin32HeapPtr< T > & pNewContents)
#else
#error Unable to detect the VC++ compiler version
#endif
{
	const DWORD cch = cb / sizeof(T);

	T const * pBeginVersionInfo = NULL, * pEndVersionInfo = NULL;
	FindVersionInfoBlock( pBuffer, cch, pBeginVersionInfo, pEndVersionInfo );
	if(!pBeginVersionInfo || !pEndVersionInfo)	// Do not modify rc if no version resource found
		throw 0;

	if (pBeginVersionInfo && pEndVersionInfo)
	{
		// copy everything up to the beginning of the version info block
		pNewContents.Add( pBuffer, pBeginVersionInfo - pBuffer );

		ProcessVersionInfoBlock( pBeginVersionInfo, pEndVersionInfo,
			pNewContents );

		// copy the rest of the stuff
		pNewContents.Add( pEndVersionInfo, cb - (pEndVersionInfo - pBuffer) );
	}
}

void CConnect::FindVersionInfoBlock(char const * pBuffer, DWORD cch,
									char const *& pBegin, char const *& pEnd)
{
	USES_CONVERSION;
	char const * const szVersionInfo = T2CA( CConnect::s_szVersionInfo );
	char const * const szBegin1 = T2CA( CConnect::s_szBegin1 );
	char const * const szBegin2 = T2CA( CConnect::s_szBegin2 );
	char const * const szEnd1 = T2CA( CConnect::s_szEnd1 );
	char const * const szEnd2 = T2CA( CConnect::s_szEnd2 );
	static size_t const cchVersionInfo = ::lstrlenA( szVersionInfo );
	static size_t const cchBegin1 = ::lstrlenA( szBegin1 );
	static size_t const cchBegin2 = ::lstrlenA( szBegin2 );
	static size_t const cchEnd1 = ::lstrlenA( szEnd1 );
	static size_t const cchEnd2 = ::lstrlenA( szEnd2 );

	char const * pchVerInfo = NULL, * pchEnd = NULL, * pch = NULL;
	bool bLoop = true;

	do
	{
		pchVerInfo = ::strstr( pBuffer, szVersionInfo );
		if (!pchVerInfo)
			break;
		else if (!::isspace( *(pchVerInfo - 1) ) ||
			!::isspace( *(pchVerInfo + ::lstrlenA( szVersionInfo )) ))
			continue;

		pch = pchVerInfo - 1;
		DWORD dw = 0;

		while (static_cast< DWORD > (pch ++ - pBuffer) < cch)
		{
			if (!::isspace( *pch ))
				continue;

			if (::strncmp( pch + 1, szBegin1, cchBegin1 ) == 0)
			{
				if (::isspace( *(pch + cchBegin1 + 1) ))
				{
					++ dw;
				}
				pch += cchBegin1 + 1;
			}
			else if (::strncmp( pch + 1, szBegin2, cchBegin2 ) == 0)
			{
				if (::isspace( *(pch + cchBegin2 + 1) ))
				{
					++ dw;
				}
				pch += cchBegin2 + 1;
			}
			else if (::strncmp( pch + 1, szEnd1, cchEnd1 ) == 0)
			{
				if (::isspace( *(pch + cchEnd1 + 1) ))
				{
					-- dw;
				}
				pch += cchEnd1 + 1;
			}
			else if (::strncmp( pch + 1, szEnd2, cchEnd2 ) == 0)
			{
				if (::isspace( *(pch + cchEnd2 + 1) ))
				{
					-- dw;
				}
				pch += cchEnd2 + 1;
			}
			else
			{
				continue;
			}

			if (::isspace( *pch ) && !dw)
			{
				while (!::isspace( *(-- pch) ))
					;
				pchEnd = pch + 1;
				bLoop = false;
				break;
			}
		}
	}
	while (bLoop && static_cast< DWORD > (++ pchVerInfo - pBuffer) < cch);

	if (!bLoop && pchVerInfo && pchEnd)
	{
		pBegin = pchVerInfo;
		pEnd = pchEnd;
	}
}

void CConnect::FindVersionInfoBlock(wchar_t const * pBuffer, DWORD cch,
									wchar_t const *& pBegin, wchar_t const *& pEnd)
{
	USES_CONVERSION;
	wchar_t const * const szVersionInfo = T2CW( CConnect::s_szVersionInfo );
	wchar_t const * const szBegin1 = T2CW( CConnect::s_szBegin1 );
	wchar_t const * const szBegin2 = T2CW( CConnect::s_szBegin2 );
	wchar_t const * const szEnd1 = T2CW( CConnect::s_szEnd1 );
	wchar_t const * const szEnd2 = T2CW( CConnect::s_szEnd2 );
	static size_t const cchVersionInfo = ::lstrlenW( szVersionInfo );
	static size_t const cchBegin1 = ::lstrlenW( szBegin1 );
	static size_t const cchBegin2 = ::lstrlenW( szBegin2 );
	static size_t const cchEnd1 = ::lstrlenW( szEnd1 );
	static size_t const cchEnd2 = ::lstrlenW( szEnd2 );

	wchar_t const * pchVerInfo = NULL, * pchEnd = NULL, * pch = NULL;
	bool bLoop = true;

	do
	{
		pchVerInfo = ::wcsstr( pBuffer, szVersionInfo );
		if (!pchVerInfo)
			break;
		else if (!::iswspace( *(pchVerInfo - 1) ) ||
			!::iswspace( *(pchVerInfo + ::lstrlenW( szVersionInfo )) ))
			continue;

		pch = pchVerInfo - 1;
		DWORD dw = 0;

		while (static_cast< DWORD > (pch ++ - pBuffer) < cch)
		{
			if (!::iswspace( *pch ))
				continue;

			if (::wcsncmp( pch + 1, szBegin1, cchBegin1 ) == 0)
			{
				if (::iswspace( *(pch + cchBegin1 + 1) ))
				{
					++ dw;
				}
				pch += cchBegin1 + 1;
			}
			else if (::wcsncmp( pch + 1, szBegin2, cchBegin2 ) == 0)
			{
				if (::iswspace( *(pch + cchBegin2 + 1) ))
				{
					++ dw;
				}
				pch += cchBegin2 + 1;
			}
			else if (::wcsncmp( pch + 1, szEnd1, cchEnd1 ) == 0)
			{
				if (::iswspace( *(pch + cchEnd1 + 1) ))
				{
					-- dw;
				}
				pch += cchEnd1 + 1;
			}
			else if (::wcsncmp( pch + 1, szEnd2, cchEnd2 ) == 0)
			{
				if (::iswspace( *(pch + cchEnd2 + 1) ))
				{
					-- dw;
				}
				pch += cchEnd2 + 1;
			}
			else
			{
				continue;
			}

			if (::iswspace( *pch ) && !dw)
			{
				while (!::iswspace( *(-- pch) ))
					;
				pchEnd = pch + 1;
				bLoop = false;
				break;
			}
		}
	}
	while (static_cast< DWORD > (++ pchVerInfo - pBuffer) < cch);

	if (!bLoop && pchVerInfo && pchEnd)
	{
		pBegin = pchVerInfo;
		pEnd = pchEnd;
	}
}

void CConnect::BackupFile(BSTR bstrFileName)
{
	static wchar_t const * const szFormat = L"%s.backup%d";
	wchar_t szOldPath[ MAX_PATH ] = { L'\0' };
	wchar_t szNewPath[ MAX_PATH ] = { L'\0' };

	for (DWORD dw = 3; dw >= 1; -- dw)
	{
		::wsprintfW( szNewPath, szFormat, bstrFileName, dw );
		if (dw != 1)
		{
			::wsprintfW( szOldPath, szFormat, bstrFileName, dw - 1 );
			if (::GetFileAttributesW( szOldPath ) == INVALID_FILE_ATTRIBUTES
				&& ::GetLastError() == ERROR_FILE_NOT_FOUND)
				continue;
			::CopyFileW( szOldPath, szNewPath, FALSE );
		}
		else
		{
			if (::GetFileAttributesW( bstrFileName ) == INVALID_FILE_ATTRIBUTES
				&& ::GetLastError() == ERROR_FILE_NOT_FOUND)
				continue;
			::CopyFileW( bstrFileName, szNewPath, FALSE );
		}
		::SetFileAttributesW( szNewPath, FILE_ATTRIBUTE_NORMAL );
	}
}

void CConnect::ProcessVersionInfoBlock(char const * pBegin, char const * pEnd,
									   CWin32HeapPtr< char > & pNewContents)
{
	USES_CONVERSION;
	char const * const szFileVersion1 = T2CA( CConnect::s_szFileVersion1 );
	char const * const szFileVersion2 = T2CA( CConnect::s_szFileVersion2 );
	char const * const szProductVersion1 = T2CA( CConnect::s_szProductVersion1 );
	char const * const szProductVersion2 = T2CA( CConnect::s_szProductVersion2 );
	static size_t const cchFileVersion1 = ::lstrlenA( szFileVersion1 );
	static size_t const cchFileVersion2 = ::lstrlenA( szFileVersion2 );
	static size_t const cchProductVersion1 = ::lstrlenA( szProductVersion1 );
	static size_t const cchProductVersion2 = ::lstrlenA( szProductVersion2 );

	char const * pchBegin = pBegin;
	char const * pch = pBegin - 1;

	VerInfo verFile, verProduct;

	while (pch ++ < pEnd)
	{
		if (!::isspace( *pch ))
			continue;

		if (::strncmp( pch + 1, szFileVersion1, cchFileVersion1 ) == 0)
		{
			pch += cchFileVersion1 + 1;
			if (::isspace( *pch ))
			{
				char const * pchEnd = NULL;
				verFile = ParseVersionInfo( ++ pch, pchEnd );

				if (pchEnd)
				{
					++ verFile;

					char szNewVer[ 24 ] = { '\0' };
					verFile.ToString( szNewVer, ',' );

					// copy everything up to the beginning of the version number
					pNewContents.Add( pchBegin, pch - pchBegin );

					const size_t nLength = ::strlen( szNewVer ) * sizeof(char);

					// copy the version number
					pNewContents.Add( szNewVer, nLength );

					pch = pchEnd;
					pchBegin = pchEnd;
				}
			}
		}
		else if (::strncmp( pch + 1, szFileVersion2, cchFileVersion2 ) == 0)
		{
			pch += cchFileVersion2 + 1;
			if (!::isalnum( *pch ))
			{
				if (verFile)
				{
					FindHelper( pch, ',' );
					FindHelper( ++ pch, '\"' );

					char const * pchEnd = pch;
					FindHelper( ++ pchEnd, '\"' );

					char szNewVer[ 24 ] = { '\0' };
					verFile.ToString( szNewVer, '.' );

					// copy everything up to the beginning of the version number
					pNewContents.Add( pchBegin, pch - pchBegin + 1 );

					const size_t nLength = ::strlen( szNewVer ) * sizeof(char);

					// copy the version number
					pNewContents.Add( szNewVer, nLength );

					pch = pchEnd;
					pchBegin = pchEnd;
				}
			}
		}
		else if (::strncmp( pch + 1, szProductVersion1, cchProductVersion1 ) == 0)
		{
			pch += cchProductVersion1 + 1;
			if (::isspace( *pch ))
			{
				char const * pchEnd = NULL;
				verProduct = ParseVersionInfo( ++ pch, pchEnd );

				if (pchEnd)
				{
					++ verProduct;

					char szNewVer[ 24 ] = { '\0' };
					verProduct.ToString( szNewVer, ',' );

					// copy everything up to the beginning of the version number
					pNewContents.Add( pchBegin, pch - pchBegin );

					const size_t nLength = ::strlen( szNewVer ) * sizeof(char);

					// copy the version number
					pNewContents.Add( szNewVer, nLength );

					pch = pchEnd;
					pchBegin = pchEnd;
				}
			}
		}
		else if (::strncmp( pch + 1, szProductVersion2, cchProductVersion2 ) == 0)
		{
			pch += cchProductVersion2 + 1;
			if (!::isalnum( *pch ))
			{
				if (verProduct)
				{
					FindHelper( pch, ',' );
					FindHelper( ++ pch, '\"' );

					char const * pchEnd = pch;
					FindHelper( ++ pchEnd, '\"' );

					char szNewVer[ 24 ] = { '\0' };
					verProduct.ToString( szNewVer, '.' );

					// copy everything up to the beginning of the version number
					pNewContents.Add( pchBegin, pch - pchBegin + 1 );

					const size_t nLength = ::strlen( szNewVer ) * sizeof(char);

					// copy the version number
					pNewContents.Add( szNewVer, nLength );

					pch = pchEnd;
					pchBegin = pchEnd;
				}
			}
		}
		else
		{
			continue;
		}
	}

	pNewContents.Add( pchBegin, pEnd - pchBegin );
}

void CConnect::ProcessVersionInfoBlock(wchar_t const * pBegin, wchar_t const * pEnd,
									   CWin32HeapPtr< wchar_t > & pNewContents)
{
	USES_CONVERSION;
	wchar_t const * const szFileVersion1 = T2CW( CConnect::s_szFileVersion1 );
	wchar_t const * const szFileVersion2 = T2CW( CConnect::s_szFileVersion2 );
	wchar_t const * const szProductVersion1 = T2CW( CConnect::s_szProductVersion1 );
	wchar_t const * const szProductVersion2 = T2CW( CConnect::s_szProductVersion2 );
	static size_t const cchFileVersion1 = ::lstrlenW( szFileVersion1 );
	static size_t const cchFileVersion2 = ::lstrlenW( szFileVersion2 );
	static size_t const cchProductVersion1 = ::lstrlenW( szProductVersion1 );
	static size_t const cchProductVersion2 = ::lstrlenW( szProductVersion2 );

	wchar_t const * pchBegin = pBegin;
	wchar_t const * pch = pBegin - 1;

	VerInfo verFile, verProduct;

	while (pch ++ < pEnd)
	{
		if (!::iswspace( *pch ))
			continue;

		if (::wcsncmp( pch + 1, szFileVersion1, cchFileVersion1 ) == 0)
		{
			pch += cchFileVersion1 + 1;
			if (::iswspace( *pch ))
			{
				wchar_t const * pchEnd = NULL;
				verFile = ParseVersionInfo( ++ pch, pchEnd );

				if (pchEnd)
				{
					++ verFile;

					wchar_t szNewVer[ 24 ] = { L'\0' };
					verFile.ToString( szNewVer, L',' );

					// copy everything up to the beginning of the version number
					pNewContents.Add( pchBegin, pch - pchBegin );

					const size_t nLength = ::wcslen( szNewVer ) * sizeof(wchar_t);

					// copy the version number
					pNewContents.Add( szNewVer, nLength );

					pch = pchEnd;
					pchBegin = pchEnd;
				}
			}
		}
		else if (::wcsncmp( pch + 1, szFileVersion2, cchFileVersion2 ) == 0)
		{
			pch += cchFileVersion2 + 1;
			if (!::iswalnum( *pch ))
			{
				if (verFile)
				{
					FindHelper( pch, L',' );
					FindHelper( ++ pch, L'\"' );

					wchar_t const * pchEnd = pch;
					FindHelper( ++ pchEnd, L'\"' );

					wchar_t szNewVer[ 24 ] = { L'\0' };
					verFile.ToString( szNewVer, L'.' );

					// copy everything up to the beginning of the version number
					pNewContents.Add( pchBegin, pch - pchBegin + 1 );

					const size_t nLength = ::wcslen( szNewVer ) * sizeof(wchar_t);

					// copy the version number
					pNewContents.Add( szNewVer, nLength );

					pch = pchEnd;
					pchBegin = pchEnd;
				}
			}
		}
		else if (::wcsncmp( pch + 1, szProductVersion1, cchProductVersion1 ) == 0)
		{
			pch += cchProductVersion1 + 1;
			if (::iswspace( *pch ))
			{
				wchar_t const * pchEnd = NULL;
				verProduct = ParseVersionInfo( ++ pch, pchEnd );

				if (pchEnd)
				{
					++ verProduct;

					wchar_t szNewVer[ 24 ] = { L'\0' };
					verProduct.ToString( szNewVer, L',' );

					// copy everything up to the beginning of the version number
					pNewContents.Add( pchBegin, pch - pchBegin );

					const size_t nLength = ::wcslen( szNewVer ) * sizeof(wchar_t);

					// copy the version number
					pNewContents.Add( szNewVer, nLength );

					pch = pchEnd;
					pchBegin = pchEnd;
				}
			}
		}
		else if (::wcsncmp( pch + 1, szProductVersion2, cchProductVersion2 ) == 0)
		{
			pch += cchProductVersion2 + 1;
			if (!::iswalnum( *pch ))
			{
				if (verProduct)
				{
					FindHelper( pch, L',' );
					FindHelper( ++ pch, L'\"' );

					wchar_t const * pchEnd = pch;
					FindHelper( ++ pchEnd, L'\"' );

					wchar_t szNewVer[ 24 ] = { L'\0' };
					verProduct.ToString( szNewVer, L'.' );

					// copy everything up to the beginning of the version number
					pNewContents.Add( pchBegin, pch - pchBegin + 1 );

					const size_t nLength = ::wcslen( szNewVer ) * sizeof(wchar_t);

					// copy the version number
					pNewContents.Add( szNewVer, nLength );

					pch = pchEnd;
					pchBegin = pchEnd;
				}
			}
		}
		else
		{
			continue;
		}
	}

	pNewContents.Add( pchBegin, pEnd - pchBegin );
}

VerInfo CConnect::ParseVersionInfo(char const * pBegin, char const *& pEnd)
{
	VerInfo ver;

	char const * pch = pBegin;

	SkipHelper( pch, ::isspace );
	if (::isdigit( *pch ))
	{
		char * pch2 = NULL;
		ver.us1 = static_cast< unsigned short >
			(::strtoul( pch, &pch2, 10 ));

		pch = pch2;
		FindHelper( pch, ',' );
		SkipHelper( ++ pch, ::isspace );

		if (::isdigit( *pch ))
		{
			ver.us2 = static_cast< unsigned short >
				(::strtoul( pch, &pch2, 10 ));

			pch = pch2;
			FindHelper( pch, ',' );
			SkipHelper( ++ pch, ::isspace );

			if (::isdigit( *pch ))
			{
				ver.us3 = static_cast< unsigned short >
					(::strtoul( pch, &pch2, 10 ));

				pch = pch2;
				FindHelper( pch, ',' );
				SkipHelper( ++ pch, ::isspace );

				if (::isdigit( *pch ))
				{
					ver.us4 = static_cast< unsigned short >
						(::strtoul( pch, &pch2, 10 ));
					pEnd = pch2;
				}
			}
		}
	}

	return ver;
}

VerInfo CConnect::ParseVersionInfo(wchar_t const * pBegin, wchar_t const *& pEnd)
{
	VerInfo ver;

	wchar_t const * pch = pBegin;

	SkipHelper( pch, ::iswspace );
	if (::iswdigit( *pch ))
	{
		wchar_t * pch2 = NULL;
		ver.us1 = static_cast< unsigned short >
			(::wcstoul( pch, &pch2, 10 ));

		pch = pch2;
		FindHelper( pch, L',' );
		SkipHelper( ++ pch, ::iswspace );

		if (::iswdigit( *pch ))
		{
			ver.us2 = static_cast< unsigned short >
				(::wcstoul( pch, &pch2, 10 ));

			pch = pch2;
			FindHelper( pch, L',' );
			SkipHelper( ++ pch, ::iswspace );

			if (::iswdigit( *pch ))
			{
				ver.us3 = static_cast< unsigned short >
					(::wcstoul( pch, &pch2, 10 ));

				pch = pch2;
				FindHelper( pch, L',' );
				SkipHelper( ++ pch, ::iswspace );

				if (::isdigit( *pch ))
				{
					ver.us4 = static_cast< unsigned short >
						(::wcstoul( pch, &pch2, 10 ));
					pEnd = pch2;
				}
			}
		}
	}

	return ver;
}

// returns true if you can go on
bool CConnect::CheckSCCForRCFile(BSTR bstrFileName)
{
	if (m_pSCC.p)
		m_pSCC.Release();

	HResult hr;
	bool bResult = true;

	try
	{
		hr = m_pDTE->get_SourceControl( &m_pSCC );
		if (!m_pSCC)
			throw 0;

		LPWSTR pwszFileName = bstrFileName;//::PathFindFileNameW( bstrFileName );
		if (!pwszFileName)
			throw 0;

		VARIANT_BOOL bUnderSCC = VARIANT_FALSE;

		hr = m_pSCC->IsItemUnderSCC( pwszFileName, &bUnderSCC );

		if (bUnderSCC != VARIANT_FALSE)
		{
			VARIANT_BOOL bCheckedOut = VARIANT_FALSE;

			hr = m_pSCC->IsItemCheckedOut( pwszFileName, &bCheckedOut );

			if (bCheckedOut == VARIANT_FALSE)
			{
				//bCheckedOut = VARIANT_TRUE;
				pwszFileName = ::PathFindFileNameW( bstrFileName );
				hr = m_pSCC->CheckOutItem( pwszFileName, &bCheckedOut );

				bResult = (bCheckedOut != VARIANT_FALSE);
			}
		}
	}
	catch (...)
	{
	}

	return bResult;
}

void CConnect::SetChangeDetectionOptions()
{
	HResult hr;

	try
	{
		CComPtr< EnvDTE::Properties > pProps;
		hr = m_pDTE->get_Properties( _bstr_t( L"Environment" ),
			_bstr_t( L"Documents" ), &pProps );
		if (!pProps)
			throw 0;

		long lCount = 0, lMax = 0;
		hr = pProps->get_Count( &lMax );

		const _bstr_t bstrDetectFileChanges( L"DetectFileChangesOutsideIDE" );
		const _bstr_t bstrAutoLoadExternal( L"AutoloadExternalChanges" );

		unsigned char num = 0;

		while (lCount ++ < lMax && num < 2)
		{
			CComPtr< EnvDTE::Property > pProp;
			pProps->Item( _variant_t( lCount ), &pProp );
			if (!pProp)
				continue;

			BSTR bstr = NULL;
			hr = pProp->get_Name( &bstr );
			if (bstr)
			{
				_bstr_t bstrName( bstr, false );

				if (bstrName == bstrDetectFileChanges)
				{
					++ num;

					_variant_t vtVal;
					hr = pProp->get_Value( &vtVal );

					m_bDetectFileChangesOutsideIDE = static_cast< bool > (vtVal);

					if (!m_bDetectFileChangesOutsideIDE)
						pProp->put_Value( _variant_t( true ) );
				}
				else if (bstrName == bstrAutoLoadExternal)
				{
					++ num;

					_variant_t vtVal;
					hr = pProp->get_Value( &vtVal );

					m_bAutoloadExternalChanges = static_cast< bool > (vtVal);

					if (!m_bAutoloadExternalChanges)
						pProp->put_Value( _variant_t( true ) );
				}
			}
		}
	}
	catch (...)
	{
	}
}

void CConnect::ResetChangeDetectionOptions()
{
	HResult hr;

	try
	{
		CComPtr< EnvDTE::Properties > pProps;
		hr = m_pDTE->get_Properties( _bstr_t( L"Environment" ),
			_bstr_t( L"Documents" ), &pProps );
		if (!pProps)
			throw 0;

		long lCount = 0, lMax = 0;
		hr = pProps->get_Count( &lMax );

		const _bstr_t bstrDetectFileChanges( L"DetectFileChangesOutsideIDE" );
		const _bstr_t bstrAutoLoadExternal( L"AutoloadExternalChanges" );

		unsigned char num = 0;

		while (lCount ++ < lMax && num < 2)
		{
			CComPtr< EnvDTE::Property > pProp;
			pProps->Item( _variant_t( lCount ), &pProp );
			if (!pProp)
				continue;

			BSTR bstr = NULL;
			hr = pProp->get_Name( &bstr );
			if (bstr)
			{
				_bstr_t bstrName( bstr, false );

				if (bstrName == bstrDetectFileChanges)
				{
					++ num;

					hr = pProp->put_Value(
						_variant_t( m_bDetectFileChangesOutsideIDE ) );
				}
				else if (bstrName == bstrAutoLoadExternal)
				{
					++ num;

					hr = pProp->put_Value(
						_variant_t( m_bAutoloadExternalChanges ) );
				}
			}
		}
	}
	catch (...)
	{
	}
}
