// Connect.h : Declaration of the CConnect

#pragma once
#include "resource.h"       // main symbols
#include "Win32HeapPtr.h"

#pragma warning( disable : 4278 )
// The following #import imports DTE based on it's LIBID
#import "libid:80cc9f66-e7d8-4ddd-85b6-d9e6cd0e93e2" version("7.0") lcid("0") raw_interfaces_only named_guids
#if _MSC_VER == 1300
// The following #import imports VC++ Project Engine System based on it's LIBID
#import "libid:9F367018-33C6-11D3-8D52-00C04F8ECDB6" version("7.0") lcid("0") raw_interfaces_only named_guids
#elif _MSC_VER == 1310
// The following #import imports VC++ Project Engine System based on it's LIBID
#import "libid:6194E01D-71A1-419F-85E3-47BA6283DD1D" version("7.0") lcid("0") raw_interfaces_only named_guids
#else
#error Unable to detect the VC++ compiler version.  You should verify the "VC++ Project Engine System" LIBID...
#endif
#pragma warning( default : 4278 )

typedef IDispEventImpl< 0, class CConnect, &__uuidof(EnvDTE::_dispBuildEvents), &EnvDTE::LIBID_EnvDTE, 7, 0 > DTE_BuildEvents;

// CConnect
class ATL_NO_VTABLE CConnect : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CConnect, &CLSID_Connect>,
	public IDispatchImpl<EnvDTE::IDTCommandTarget, &EnvDTE::IID_IDTCommandTarget, &EnvDTE::LIBID_EnvDTE, 7, 0>,
	public IDispatchImpl<AddInDesignerObjects::_IDTExtensibility2, &AddInDesignerObjects::IID__IDTExtensibility2, &AddInDesignerObjects::LIBID_AddInDesignerObjects, 1, 0>,
	public DTE_BuildEvents
{
public:
	CConnect();

	DECLARE_REGISTRY_RESOURCEID(IDR_ADDIN)
	DECLARE_NOT_AGGREGATABLE(CConnect)

BEGIN_COM_MAP( CConnect )
	COM_INTERFACE_ENTRY(AddInDesignerObjects::IDTExtensibility2)
	COM_INTERFACE_ENTRY(EnvDTE::IDTCommandTarget)
	COM_INTERFACE_ENTRY2(IDispatch, AddInDesignerObjects::IDTExtensibility2)
END_COM_MAP()

BEGIN_SINK_MAP( CConnect )
	SINK_ENTRY_EX( 0, __uuidof(EnvDTE::_dispBuildEvents), 3, OnBuildBegin )
END_SINK_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

public:
	//IDTExtensibility2 implementation:
	STDMETHOD(OnConnection)(IDispatch * Application, AddInDesignerObjects::ext_ConnectMode ConnectMode, IDispatch *AddInInst, SAFEARRAY **custom);
	STDMETHOD(OnDisconnection)(AddInDesignerObjects::ext_DisconnectMode RemoveMode, SAFEARRAY **custom );
	STDMETHOD(OnAddInsUpdate)(SAFEARRAY **custom );
	STDMETHOD(OnStartupComplete)(SAFEARRAY **custom );
	STDMETHOD(OnBeginShutdown)(SAFEARRAY **custom );
	
	//IDTCommandTarget implementation:
	STDMETHOD(QueryStatus)(BSTR CmdName, EnvDTE::vsCommandStatusTextWanted NeededText, EnvDTE::vsCommandStatus *StatusOption, VARIANT *CommandText);
	STDMETHOD(Exec)(BSTR CmdName, EnvDTE::vsCommandExecOption ExecuteOption, VARIANT *VariantIn, VARIANT *VariantOut, VARIANT_BOOL *Handled);

	// _dispBuildEvents implementation:
	STDMETHOD(OnBuildBegin)(EnvDTE::vsBuildScope Scope, EnvDTE::vsBuildAction Action);

// helper functions
private:
	void IncrementVersion(bool bAll);
	void ProcessProjectGroups(LPCTSTR pszGroup);
	void ProcessProjects(EnvDTE::Project * pProject, LPCTSTR pszGroup);
	void ProcessVCProjects(EnvDTE::Project * pProject);
	void ProcessVCProjectItems(EnvDTE::ProjectItems * pItems);
	void ProcessVCProjectFile(BSTR bstrFileName);
	void ProcessVCProjectRCFile(BSTR bstrFileName);
	void ProcessVCProjectRCFileInternal(BSTR bstrFileName,
		CWin32HeapPtr< char > & pNewContentsA,
		CWin32HeapPtr< wchar_t > & pNewContentsW);
	void BackupFile(BSTR bstrFileName);
	void FixUnicodeText(void * pvBuffer, DWORD cb);
	void WriteRCFile(BSTR bstrFileName,
		CWin32HeapPtr< char > & pNewContentsA,
		CWin32HeapPtr< wchar_t > & pNewContentsW, bool bUnicode);
	bool CheckSCCForRCFile(BSTR bstrFileName);
	void SetChangeDetectionOptions();
	void ResetChangeDetectionOptions();

	// RC processing functions
	template < typename T >
	void ProcessRC(T const * pBuffer, DWORD cb, CWin32HeapPtr< T > & pNewContents);
	void FindVersionInfoBlock(char const * pBuffer, DWORD cch,
		char const *& pBegin, char const *& pEnd);
	void FindVersionInfoBlock(wchar_t const * pBuffer, DWORD cch,
		wchar_t const *& pBegin, wchar_t const *& pEnd);
	void ProcessVersionInfoBlock(char const * pBegin, char const * pEnd,
		CWin32HeapPtr< char > & pNewContents);
	void ProcessVersionInfoBlock(wchar_t const * pBegin, wchar_t const * pEnd,
		CWin32HeapPtr< wchar_t > & pNewContents);
	struct VerInfo ParseVersionInfo(char const * pBegin, char const *& pEnd);
	struct VerInfo ParseVersionInfo(wchar_t const * pBegin, wchar_t const *& pEnd);

// inline functions
	template < typename T >
	void SkipHelper(T const *& ptr, T const & skip) const
	{
		while (*ptr == skip)
			++ ptr;
	}

	template < typename T, typename Pred >
	void SkipHelper(T const *& ptr, Pred & pred) const
	{
		while (pred( *ptr ))
			++ ptr;
	}
	template < typename T >
	void FindHelper(T const *& ptr, T const & skip) const
	{
		while (*ptr != skip)
			++ ptr;
	}

	template < typename T, typename Pred >
	void FindHelper(T const *& ptr, Pred & pred) const
	{
		while (!pred( *ptr ))
			++ ptr;
	}

private:
	static const TCHAR * const s_szVersionInfo;
	static const TCHAR * const s_szBegin1;
	static const TCHAR * const s_szBegin2;
	static const TCHAR * const s_szEnd1;
	static const TCHAR * const s_szEnd2;
	static const TCHAR * const s_szFileVersion1;
	static const TCHAR * const s_szFileVersion2;
	static const TCHAR * const s_szProductVersion1;
	static const TCHAR * const s_szProductVersion2;

private:
	CComPtr< EnvDTE::_DTE > m_pDTE;
	CComPtr< EnvDTE::AddIn > m_pAddInInstance;
	CComPtr< EnvDTE::_BuildEvents > m_pEvents;
	CComPtr< EnvDTE::SourceControl > m_pSCC;
	bool m_bDetectFileChangesOutsideIDE;
	bool m_bAutoloadExternalChanges;
};

OBJECT_ENTRY_AUTO(__uuidof(Connect), CConnect)
